package com.ruoyi.oa.service;

import com.ruoyi.oa.domain.LaborCostData;
import com.ruoyi.oa.domain.vo.AttendanceMonthlyCount;
import com.ruoyi.oa.domain.vo.SysOaAttendanceVo;
import com.ruoyi.oa.domain.bo.SysOaAttendanceBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.ruoyi.oa.domain.vo.SysUserVo;

import java.util.Collection;
import java.util.Date;
import java.util.List;

/**
 * 人员考勤Service接口
 *
 * @author hdka
 * @date 2024-11-05
 */
public interface ISysOaAttendanceService {

    /**
     * 查询人员考勤
     */
    SysOaAttendanceVo queryById(Long id);

    /**
     * 查询人员考勤列表
     */
    TableDataInfo<SysOaAttendanceVo> queryPageList(SysOaAttendanceBo bo, PageQuery pageQuery);

    /**
     * 查询人员考勤列表
     */
    List<SysOaAttendanceVo> queryList(SysOaAttendanceBo bo);

    /**
     * 新增人员考勤
     */
    Boolean insertByBo(SysOaAttendanceBo bo);

    /**
     * 修改人员考勤
     */
    Boolean updateByBo(SysOaAttendanceBo bo);

    /**
     * 校验并批量删除人员考勤信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 工人列表
     *
     * @param bo
     * @return
     */
    TableDataInfo<SysUserVo> workerList(SysOaAttendanceBo bo);

    /**
     * 批量插入
     * @param bo
     * @return
     */
    int insertBatch(SysOaAttendanceBo bo);

    /**
     * 人力成本计算接口
     *
     * @param time 时间
     */
    List<LaborCostData> workerCalc(Date time);

    /**
     * 删除当月某日所有人的签到记录
     * @param day 日期
     * @return
     */
    int delOaAttendanceAll(Long day);

    /**
     * @param refDate
     * @return
     */
    List<AttendanceMonthlyCount> selectLastSixMonthsByMonth(String refDate);

    AttendanceMonthlyCount selectAttendanceMonthlyCountByMonth(String refDate);

    List<AttendanceMonthlyCount> selectMonthlyCounts(String refDate);

}
